--- old/usr/src/lib/pkcs11/pkcs11_softtoken/common/softASN1.c	Fri Jul  6 15:55:07 2018
+++ new/usr/src/lib/pkcs11/pkcs11_softtoken/common/softASN1.c	Fri Jul  6 15:55:07 2018
@@ -22,6 +22,7 @@
 /*
  * Copyright (c) 2004, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2012 Milan Jurik. All rights reserved.
+ * Copyright (c) 2018, Joyent. Inc.
  */
 
 #include <stdlib.h>
@@ -87,7 +88,7 @@
 	 * clear out potentially sensitive data before that happens.
 	 */
 	if (dst->big_value != NULL)
-		(void) memset(dst->big_value, 0x0, dst->big_value_len);
+		explicit_bzero(dst->big_value, dst->big_value_len);
 
 	padding = (src->big_value[0] < 0x80) ? 0 : 1;
 	dst->big_value_len = src->big_value_len + padding;
@@ -338,10 +339,7 @@
 
 cleanup_rsapri2asn:
 
-	if (tmp_pad.big_value != NULL) {
-		(void) memset(tmp_pad.big_value, 0x0, tmp_pad.big_value_len);
-		free(tmp_pad.big_value);
-	}
+	freezero(tmp_pad.big_value, tmp_pad.big_value_len);
 
 	if (key_asn != NULLBER)
 		ber_free(key_asn, 1);
@@ -527,10 +525,7 @@
 
 cleanup_dsapri2asn:
 
-	if (tmp_pad.big_value != NULL) {
-		(void) memset(tmp_pad.big_value, 0x0, tmp_pad.big_value_len);
-		free(tmp_pad.big_value);
-	}
+	freezero(tmp_pad.big_value, tmp_pad.big_value_len);
 
 	if (key_asn != NULLBER)
 		ber_free(key_asn, 1);
@@ -701,10 +696,7 @@
 
 cleanup_dhpri2asn:
 
-	if (tmp_pad.big_value != NULL) {
-		(void) memset(tmp_pad.big_value, 0x0, tmp_pad.big_value_len);
-		free(tmp_pad.big_value);
-	}
+	freezero(tmp_pad.big_value, tmp_pad.big_value_len);
 
 	if (key_asn != NULLBER)
 		ber_free(key_asn, 1);
@@ -893,10 +885,7 @@
 
 cleanup_x942dhpri2asn:
 
-	if (tmp_pad.big_value != NULL) {
-		(void) memset(tmp_pad.big_value, 0x0, tmp_pad.big_value_len);
-		free(tmp_pad.big_value);
-	}
+	freezero(tmp_pad.big_value, tmp_pad.big_value_len);
 
 	if (key_asn != NULLBER)
 		ber_free(key_asn, 1);
@@ -1240,11 +1229,7 @@
 
 cleanup_asn2rsapri:
 
-	if (tmp_nopad.big_value != NULL) {
-		(void) memset(tmp_nopad.big_value, 0x0,
-		    tmp_nopad.big_value_len);
-		free(tmp_nopad.big_value);
-	}
+	freezero(tmp_nopad.big_value, tmp_nopad.big_value_len);
 
 	if (p8obj_asn != NULLBER)
 		ber_free(p8obj_asn, 1);
@@ -1448,11 +1433,7 @@
 
 cleanup_asn2dsapri:
 
-	if (tmp_nopad.big_value != NULL) {
-		(void) memset(tmp_nopad.big_value, 0x0,
-		    tmp_nopad.big_value_len);
-		free(tmp_nopad.big_value);
-	}
+	freezero(tmp_nopad.big_value, tmp_nopad.big_value_len);
 
 	if (p8obj_asn != NULLBER)
 		ber_free(p8obj_asn, 1);
@@ -1632,11 +1613,7 @@
 
 cleanup_asn2dhpri:
 
-	if (tmp_nopad.big_value != NULL) {
-		(void) memset(tmp_nopad.big_value, 0x0,
-		    tmp_nopad.big_value_len);
-		free(tmp_nopad.big_value);
-	}
+	freezero(tmp_nopad.big_value, tmp_nopad.big_value_len);
 
 	if (p8obj_asn != NULLBER)
 		ber_free(p8obj_asn, 1);
@@ -1840,11 +1817,7 @@
 
 cleanup_asn2x942dhpri:
 
-	if (tmp_nopad.big_value != NULL) {
-		(void) memset(tmp_nopad.big_value, 0x0,
-		    tmp_nopad.big_value_len);
-		free(tmp_nopad.big_value);
-	}
+	freezero(tmp_nopad.big_value, tmp_nopad.big_value_len);
 
 	if (p8obj_asn != NULLBER)
 		ber_free(p8obj_asn, 1);
@@ -1864,7 +1837,7 @@
 CK_RV
 soft_asn1_to_object(soft_object_t *objp, uchar_t *buf, ulong_t buf_len)
 {
-	CK_RV 		rv = CKR_OK;
+	CK_RV		rv = CKR_OK;
 	CK_OBJECT_CLASS class = objp->class;
 	CK_KEY_TYPE	keytype = objp->key_type;
 	private_key_obj_t *pvk;
